this.name					= "Famous Planets 2 Launch Script";
this.author					= "P.A.Groove(Concept+Artwork), Thargoid+Svengali(Script)";
this.copyright				= "Creative Commons: attribution, non-commercial, sharealike.";
this.description			= "Planet-textures replacement and music for some special systems. Compatible to SystemRedux and OXPConfig.";
this.version				= "2.0.2";

/* this.logging, this.audio, this.extraA and this.extraB are for compatability with OXPConfig.oxp.

        this.logging - turns logging to stderr.txt and JSConsole on and off (off by default).
        this.audio - turns the tunes at witchspace entry and undocking from the main station in FP locations on and off (on by default).
        this.extraA - turns on/off console messages after witchspace arrival and main station undocking in FP location (on by default).
        this.extraB - turns on/off planet texturing (on by default).
*/
this.SR1 = null;

this.startUp = this.reset = function () {
	delete this.startUp;
	if (worldScripts["System Redux 1.0"]) this.SR1 = worldScripts["System Redux 1.0"];
	if (worldScripts["System Redux 1.2"]) this.SR1 = worldScripts["System Redux 1.2"];
	if (this.SR1 != null) {
		if (this.SR1.startUp) {
			this.SR1.startUp();
			delete this.SR1.startUp;
		}
	}
	this.planetList = new Array;
	this.delayedStartFP2();	
}

this.delayedStartFP2 = function() {
	log(this.name + " " + this.version + " loaded.");
	this.resetVariables();
	this.setUpArrays();
	if (this.SR1 != null) {
		log (this.name + ":  " + this.SR1.name + " was detected by FP2WOG2");
		this.canRestore = true;
		for (var i = 0; i < this.planetList.length; i++) {
			for(var j=0; j<this.planetList[i].length; j++) {
				this.restoreList[i][j] = this.SR1.system_info[((i*256)+1+this.planetList[i][j])];
				this.SR1.system_info[((i*256)+1+this.planetList[i][j])] = 0;
				if (!this.restoreList[i]) {
					this.useDynamicList = false;
				}
			}
		}
		if (!this.useDynamicList) {
			this.restoreList = new Array;
			this.restoreList = this.SR1.system_info.slice(); 
			log("FamousPlanets2","FP2: Falling back to fixed mode"); 
		} 
	}
	if (worldScripts["Deep Horizon - Systems API"])  {
		log(this.name + ":  Deep Horizon - Systems Script Found.  Updating Deep Horizon - Systems behavior through DH_SysAPI.");
		var DH_Sys = worldScripts["Deep Horizon - Systems API"]
		this.canRestore = true;
		DH_Sys.registerOverrideOXP(this.name,"restoreNormalTexturesCheck");
		for (var i = 0; i < this.planetList.length; i++) {
			for (var j = 0; j < this.planetList[i].length; j++) {
				DH_Sys.excludeSystem(i,this.planetList[i][j],{TextureMP:true, AddPlanets:false, AddMoons:false, TxtPlanets:false, TxtMoons:false, ReduSun:false})
			}
		}
	}
} 

this.resetVariables = function() {
	this.logging = false;
	this.audio = true;
	this.extraA = true;
	this.extraB = true;
	this.canRestore = false;
	this.hasRestored = false;
	this.useDynamicList = true;
}

this.setUpArrays = function() 	{
	log (this.name + ":  Setting Up Arrays.");
	this.planetList = [[],[],[],[],[],[],[],[]]; // galaxies 0-7
	this.planetList[0] = [7, 129, 39, 124, 246, 99, 55, 154, 147, 141, 73, 50, 89, 35, 227, 250, 188, 111, 186, 101, 222, 29, 23, 177, 93, 131, 42, 21, 100, 28, 16, 221, 36, 198, 150, 62, 172, 241, 200, 18, 86, 126, 3, 153, 132, 90, 44, 228, 13]; // Lave, Zaonce, Reorte, Tionisla, Tianve, Teraed, Leesti, Isinor, Diso, Lerelace, Aronar, Aesbion, Beusrior, Isence, Qutiri, Xexedi, Tibionis, Reinen, Zarece, Laenin, Rilace, Atrabiin, Onrira, Larais, Xeeranre, Zadies, Anarlaqu, Sotiqu, Vetitice, Arexe, Rizala, Zasoceat, Reesdice, Xezaor, Xeer, Esusti, Esveor, Qurave, Edorte, Teanrebi, Velete, Anerbe, Biarge, Aona, Entizadi, Ontiat, Esesla, Biramabi, Ontimaxe, 
	this.planetList[1] = [202, 114, 42, 109, 127, 207, 136, 6, 24, 48, 53, 78, 204, 193, 221, 236, 66, 58, 88, 140, 189, 65, 144, 178, 45, 113, 115, 57, 94, 29, 33, 74, 122, 54, 23, 188, 82 ]; // Isonza, Teonan, Soorte, Edsodi, Ceinerxe, Inxexeat, Orrionti, Esbete, Maesaron, Atzaxe, Ausar, Erlaened, Zatebiso, Orarra, Abege, Zageuser, Onatbeza, Xeate, Gerebied, Zaaxeve, Resori, Ceiner, Diraza, Usoron, Veerge, Ustile, Anvere, Erlage, Laceteed, Esrece, Diti, Cediza, Riedin, Rave, Ridiusla, Laatso, Vezaaes
	this.planetList[2] = [58, 165, 106, 198, 164]; // Radiqu, Edxeri, Ceedleon, Atius,Rerebi
	this.planetList[3] = [13, 47, 130, 18, 122]; // Mavelege, Bemate, Cebitiza,  Mausra, Ensoor
	this.planetList[4] = [16, 193, 231, 92, 9]; // Zaaner, Vebi, Inenares, Azaenbi, Dioris
	this.planetList[5] = [151, 6, 85, 146, 240]; // Teesso, Oresmaa, Celaan, Ariqu, Inesbe
	this.planetList[6] = [189, 146, 130, 118, 37]; // Isdilaon, Aenbi, Ataer, Orreedon, Qutegequ
	this.planetList[7] = [177, 31, 211, 157, 20]; // Ceenza, Aarzari, Biatzate, Inbein, Oredrier
	this.restoreList = [[],[],[],[],[],[],[],[]]; // galaxies 0-7
}

this.systemCheck = function(planetNum,galNum) {
	if(this.planetList[galNum].indexOf(planetNum) != -1) return true;
	else return false;
}

this.shipWillLaunchFromStation = this.shipWillExitWitchspace = function() {
	if(this.extraB && this.canRestore && this.hasRestored) this.hasRestored = false;
	// Reset to handle SystemRedux when user possibly changed texture-switch (this.extraB) for FamousPlanets via console or OXPConfig 
	this.restoreNormalTexturesCheck();
    if(this.systemCheck(system.ID, galaxyNumber)) {
		if (this.hasRestored) return; 
		if(this.extraB) {
			system.mainPlanet.Texture = system.name + '.png';
			if(this.logging) log(system.name + " planet texture applied.");
		}
	}
}

this.shipWillEnterWitchspace = this.shipWillDockWithStation = this.shipDied = function(dummy) {
    if(this.systemCheck(system.ID, galaxyNumber)) {
		if(this.audio) Sound.stopMusic(system.name + '_Theme.ogg');
		if(this.audio && this.logging) {log("Stopping " + system.name + " theme music.")};
	}
}


this.shipExitedWitchspace = function() {
	if(this.logging) {log("Player in galaxy " + (galaxyNumber+1) + " at " + system.name + " (" + system.ID + ")."); };
	if(this.systemCheck(system.ID, galaxyNumber)) {
		if(this.extraA) {player.consoleMessage("Welcome to " + system.name + " Commander " + player.name) }; // display the welcome message
		if(this.audio) {Sound.playMusic(system.name + '_Theme.ogg')};
		if(this.audio && this.logging) {log("Playing " + system.name + " music on witchspace arrival.")};
	}
}

this.shipLaunchedFromStation = function(station) {
	if(this.systemCheck(system.ID, galaxyNumber) && station.isMainStation) { // if player launched from the main station in a FP system. 
		if(this.extraA) {player.consoleMessage("We hope you enjoyed " + system.name + " station Commander " + player.name) }; // display launch message
		if(this.audio) {Sound.playMusic(system.name + '_Theme.ogg')};
		if(this.audio && this.logging) {log("Playing " + system.name + " music after launch from main station.")};
    }
}

this.restoreNormalTexturesCheck = function () {
	if (!this.extraB && this.canRestore && !this.hasRestored) {
		if (this.SR1 != null) this.restoreSR1();
		if (worldScripts["SystemRedux2API"])  this.restoreSR2();
		this.hasRestored = true;
	} 
}

this.restoreSR1 = function () {
	if (this.restoreList.length >2000) {
		this.SR1.system_info = new Array; //done to clear the array of existing data
		this.SR1.system_info = this.restoreList.splice();
	}
	else {
		for (var i = 0; i < this.planetList.length; i++) {
			for(var j=0; j<this.planetList[i].length; j++) {
				this.SR1.system_info[(i*256)+this.planetList[i][j+1]] = this.restoreList[i][j];
			}
		}
	}
}

this.restoreSR2 = function () {
	log(this.name + ":  FP2 texturing disabled via OXPconfig.  Updating SR2 behavior through SR2API.");
	var SR2 = worldScripts["SystemRedux2API"]
	for (var i = 0; i < this.planetList.length; i++) {
		for (var j = 0; j < this.planetList[i].length; j++) {
			SR2.excludeSystem(i,this.planetList[i][j],{TextureMP:false, AddPlanets:false, AddMoons:false, TxtPlanets:false, TxtMoons:false, ReduSun:false})
		}
	}
}